var util = require('util');
var func=null,
	clc=null,
	request=null,
	pkg=null;

module.exports=function(fu){
	func=fu;
	clc=func.clc;
	request=func.request;
	return function(){
		try {
			pkg=require(func.esmpackage);
		} catch(e) {
			console.log(clc.red('cannot read esm.json'));
			process.exit();
		}
		
		if (func.p.subcommand) {
			if (func.p.subcommand == 'add') {
				func.prompt({name:{
					pattern: /^[\w\-]+$/,
					message: 'Name can only contains word or dashes',
					required: true
				}},function(e,r){
					if(!r){
						console.log('\n'+clc.empty('add owner cancelled'));
					} else if (r.name){
						request(func.apiurl+'user/'+r.name, function (error, response, body) {
							if (!error && response.statusCode == 200) {
								var rslt= JSON.parse(body);
								if (rslt && rslt.name) {
									pkg.owner=pkg.owner||[];
									if (util.isString(pkg.owner)) {
										pkg.owner=[pkg.owner];
									}
									pkg.owner.push(rslt.full_name+' <'+rslt.email+'>');
									func.createFile(func.esmpackage,JSON.stringify(pkg,true,'  '),function(rslt2){
										if (rslt2) {
											console.log('\n'+clc.bold('success')+' '+rslt.full_name+' <'+rslt.email+'> added');
										} else {
											console.log(clc.red('cannot write esm.json file'));
										}
									});
								} else if(rslt.err){
									console.log(clc.red(rslt.err));
								}
							}
						});
					}
				});
			} else if (func.p.subcommand == 'rm') {
				
			} else if (func.p.subcommand == 'ls') {
				listOwner();
			} else {
				console.log(clc.red('invalid sub command '+clc.bold(func.p.subcommand)));
			}
		} else {
			listOwner();
		}
	};
};

function listOwner() {
	pkg.owner=pkg.owner||[];
	if (util.isString(pkg.owner)) {
		pkg.owner=[pkg.owner];
	}
	pkg.owner.unshift(pkg.author);
	func.formatOutput(pkg.owner);
}