var cs = require('../change_case');
var f;
module.exports=function(fu){
	f=fu;
	var clc=f.clc,
		wd=f.workingdir,
		cfg,
		id;
		
	try {
		cfg=require(wd+'esm.json');
		
	} catch(err) {
		cfg=null;
	}
	if (cfg) {
		id=cs.camel(cfg.name);
	}
	return function(cb){
		if (!id) {
			console.log(clc.error(f.msg.esm_pkg_doesnt_exists));
			return;
		}
		//console.log('p==>',f.p);
		//process.exit();
		var scs=f.p.subcommand,
			pluginName,
			sc;
			
		if (scs && scs.length) {
			scs=!Array.isArray(scs)?[scs]:scs;
			sc=scs[0];
			if (scs.length > 1) {
				pluginName=scs[1];
			}
			
			if (sc=='ls') {
				ls(cfg);
			} else if(sc=='add' || sc=='install'){
				if (!pluginName) {
					console.log(clc.empty(f.sprintf(f.msg.invalid_params,'cordova_plugin_id')));
					return;
				}
				add(cfg,pluginName);
				save(cfg);
			} else if(sc=='rem' || sc=='remove' || sc=='del' || sc=='delete' || sc=='uninstall'){
				if (!pluginName) {
					console.log(clc.empty(f.sprintf(f.msg.invalid_params,'cordova_plugin_id')));
					return;
				}
				remove(cfg,pluginName);
				save(cfg);
			} else {
				console.log(clc.error(f.sprintf(f.msg.invalid_sub_command,sc)))
			}
		} else {
			ls(cfg);
		}
	};
};

function ls(cfg) {
	var l='plugins';
	if (cfg[l] && cfg[l].length) {
		f.formatOutput(cfg[l],2);
	} else {
		console.log(clc.empty(f.msg.no_plugin_deps))
	}
}

function add(cfg,plugin) {
	var l='plugins';
	cfg[l]=cfg[l]||[];
	if (cfg[l].indexOf(plugin) < 0) {
		cfg[l].push(plugin);
	}
}

function remove(cfg,plugin) {
	var l='plugins';
	cfg[l]=cfg[l]||[];
	var i=cfg[l].indexOf(plugin);
	if (i > -1) {
		cfg[l].splice(i,1);
	}
}

function save(cfg){
	f.createFile(f.esmpackage,JSON.stringify(cfg,true,'  '),function(r){
		if (r) {
			console.log(f.clc.info(f.msg.pkg_updated));
		} else {
			console.log(f.clc.red(f.sprint(f.msg.cannot_write_file,'esm.json')));
		}
	});
}