var fs		= require("fs");
var clc		= null,
	func	= null,
	wd		= null,
	cfg		= null,
	depSort	= [],
	cs		= require('./../change_case');

var readmeFiles=function(){
	var a=[];
	var aex=['md','MD','Md','markdown','Markdown','MarkDown','MARKDOWN'],
		afn=['readme','README','Readme','ReadMe'];
	for(var i=0;i<afn.length;i++){
		for(var j=0;j<aex.length;j++){
			a.push(afn[i]+'.'+aex[j]);
		}
	}
	return a;
}();
function getReadme() {
	function getName() {
		for(var i=0;i<readmeFiles.length;i++){
			if (fs.existsSync('./'+readmeFiles[i])) {
				return './'+readmeFiles[i];
			}
		}
		return false;
	}
	var fn=getName();
	if (fn) {
		return fs.readFileSync(fn,'utf8');
	} else {
		return null;
	}
}

module.exports=function(fu){
	var func=fu,
		clc=func.clc,
		wd=func.workingdir;
	try {
		cfg=require(wd+'esm.json');
	} catch(err) {
		cfg=null;
	}
	return function(){
		function _publish(pack,isUpdate){
			var id=cs.camel(cfg.name);
			var frmdt=func.JSONflatten(cfg);
			//for(var ki in cfg){
			//	frmdt[ki]=JSON.stringify(cfg[ki])
			//}
			frmdt.pack=fs.createReadStream(pack);
			frmdt.readme=getReadme()||'';
			//var frmdt={
			//	//config:JSON.stringify(cfg),
			//	pack:fs.createReadStream(pack)
			//};
			//func.request.forever();
			var requ=func.request.post;
			var uri=func.apiurl+'package/';
			if(isUpdate){
				requ=func.request.put;
				uri+=id;
			} else {
				frmdt.id=id;
			}
			//console.log('uri==>',uri);
			requ({url:uri,formData:frmdt}, function (error, response, body) {
				//console.log('error=>',error);
				//console.log('body=>',body);
				if (!error && response.statusCode == 200) {
					var rslt= JSON.parse(body);
					if (!rslt.s) {
						console.log(clc.red(rslt.e.toString()));
						return;
					}
					//if (rslt.s) {
					console.log(clc.bold.cyan('published:')+' '+rslt.dt.id+'@'+rslt.dt.version+'');
					//}
					//console.log('rslt==>',rslt);
					//console.log(clc.bold.cyan('success:')+' packageId = '+rslt.auth.name);
					//if (rslt && rslt.auth && rslt.auth.name) {
					//	console.log(clc.bold.cyan('success:')+' username = '+rslt.auth.name);
					//} else if(rslt && rslt.err){
					//	console.log(clc.red(rslt.err));
					//}
				} else if(error){
					//var se=('Error: read ECONNRESET,Error: socket hang up').toLowerCase().split(',');
					//if (se.indexOf(error.toString().trim().toLowerCase())>-1) {
					//	//re check
					//
					//	console.log('published:'+cfg.name+'@'+cfg.version);
					//} else {
						console.log(clc.error(error));
					//}
				} else {
					console.log(clc.error('unknown error'));
				}
			});
		}
		function prepublish(isUpdate) {
			//console.log('pre publish dipanggil');
			isUpdate=isUpdate||false;
			func.build(function(e){
				if (e) { console.log(clc.red(e.toString())); return; }
				console.log(clc.empty('build completed'));
				
				func.test(function(e){
					//console.log('ngetessssss...',e);
					//if (e) { console.log(clc.red(e.toString())); return; }
					if (e) { console.error(e); return; }
					console.log(clc.empty('dist test completed'));
					
					func.pack(function(r){
						//console.log('r===>',r);
						if (r) {
							_publish(r,isUpdate);
						} else {
							console.log('error pack file');
						}
					});
					
				});
				
				//func.static(function(e){
				//	if (e) { console.log(clc.red(e.toString())); return; }
				//	console.log(clc.empty('bundle static completed'));
				//	
				//	func.test(function(e){
				//		//console.log('ngetessssss...',e);
				//		//if (e) { console.log(clc.red(e.toString())); return; }
				//		if (e) { console.error(e); return; }
				//		console.log(clc.empty('dist test completed'));
				//		
				//		func.pack(function(r){
				//			//console.log('r===>',r);
				//			if (r) {
				//				_publish(r,isUpdate);
				//			} else {
				//				console.log('error pack file');
				//			}
				//		});
				//		
				//	})
				//	
				//})
			});
		}
		var username='';
		func.request(func.apiurl+'me',function(error, response, body) {
			if (error) {
				console.error(error);
			} else {
				var rslt= JSON.parse(body);
				if (rslt && rslt.dt && rslt.dt.userId) {					
					username=rslt.dt.userId;
					
					func.request(func.apiurl+'package/'+cfg.name, function (error, response, body) {
						if (!error && response.statusCode == 200) {
							var rslt= JSON.parse(body);
							if (rslt && rslt.s && !rslt.dt) {
								//initial release, test name
								//func.request(func.apiurl+'package.testname/'+cfg.name, function (error, response, body) {
								//	if (!error && response.statusCode == 200) {
								//		var rslt2= JSON.parse(body);
								//		if (rslt2 && rslt2.s) {
											prepublish();
								//		} else {
								//			console.log(clc.empty(rslt2.err));
								//		}
								//	} else {
								//		console.log(clc.empty('connection error'));
								//	}
								//});
							} else {
								console.log(clc.empty('package exists, updating...'));
								prepublish(true);
							}
							//else if(rslt && rslt.name){
							//	//release, check owner
							//	var validowner=false;
							//	if (rslt.owners) {
							//		//console.log(username);
							//		//console.log(rslt.owners.length);
							//		for (var i=0;i<rslt.owners.length;i++){
							//			if (rslt.owners[i].name==username) {
							//				validowner=true;
							//				break;
							//			}
							//		}
							//		if (validowner) {
							//			func.request(func.apiurl+'package.testversion/'+cfg.name+'@'+cfg.version, function (verror, vresponse, vbody) {
							//				if (!verror && vresponse.statusCode == 200) {
							//					var vrslt= JSON.parse(vbody);
							//					if (vrslt.v) {
							//						console.log(clc.empty(cfg.name+'@'+cfg.version +' has published, please update package version'));
							//					} else {
							//						prepublish();
							//					}
							//				} else {
							//					console.log('connection error');
							//				}
							//			});
							//		} else {
							//			console.log(clc.empty('you are not package owner'));
							//		}
							//	} else {
							//		console.log(clc.empty('you are not package owner..'));
							//	}
							//} else {
							//	console.log(clc.red('connection error'));
							//}
						} else {
							console.log(clc.empty('connection error'));
						}
					});
				} else {
					console.log(clc.empty(func.msg.not_logged_in));
				}
			}
		});
		//func.pack(function(r){
		//	if (!r) {
		//		console.log('error pack file');
		//	} else {
		//		_publish(r);
		//	}
		//});
	};
};
