var util = require('util');

module.exports=(function(){
	var x={options:{},command:'',arguments:{}};
	var last='';
	var stopCmd=false;
	function opt(k,v) {
		if (typeof(v)=='undefined') {
			v=true;
		}
		if (typeof(x.options[k])=='undefined' || x.options[k]===true) {
			x.options[k]=v;
		} else {
			if (!util.isArray(x.options[k])) {
				x.options[k]=[x.options[k]];
			}
			if (v!==true) {
				x.options[k].push(v);
			}
		}
	}
	function arg(a,v){
		x.arguments[a]=v;
	}
	process.argv.forEach(function(val, i, array) {
		if (i>1) {
			var smin=val.match(/^\-(\w+)/);
			var sminmin=val.match(/^\-\-(\w+)/);
			var scmd=val.match(/^(\w+)/);
			var sarg=val.match(/(\w+).*\=(.*)/);
			if (scmd && scmd.length && scmd[1] && !x.command && !stopCmd) {
				x.command=scmd[1];
			} else {
				if (smin && smin.length && smin[1]) {
					if(smin[1].length > 1){
						last='';
						for(var j=0;j<smin[1].length;j++){
							opt(smin[1][j]);
						}
					} else {
						last=smin[1];
						opt(smin[1]);
					}
				} else if (sminmin && sminmin.length && sminmin[1]) {
					last=sminmin[1];
					opt(sminmin[1]);
				} else if(sarg && sarg.length > 2){
					arg(sarg[1],sarg[2]);
				} else {
					opt(last,val);
				}
			}
			stopCmd=true;
		}
	});
	if (x.options['']) {
		x.subcommand=x.options[''];
		delete(x.options['']);
	}
	
	//console.log('x==>',x);
	return x;
}());