var rollup	= require('../rollup'),
	cs		= require('../change_case'),
	path	= require('path'),
	ncp		= require('ncp');

module.exports=function(fu){
	var func=fu,
		clc=func.clc,
		wd=func.workingdir,
		cfg,
		id;
		
	try {
		cfg=require(wd+'esm.json');
		
	} catch(err) {
		cfg=null;
	}
	if (cfg) {
		id=cs.camel(cfg.name);
	}
	return fu.build=function(cb){
		if (!id) {
			console.log(clc.error('esm package does not exist'));
			return;
		}
		var bopts={
			format: 'umd',
			dest: path.resolve( cfg.dir.dist.app,id+'.js'),
			moduleId: id,
			moduleName: id
		},
		boptse=fu.update({},bopts,{
			dest: path.resolve( cfg.dir.dist.editor,id+'.js'),
		});
		//console.log('bopts==>',bopts);
		fu.deleteFolderRecursive(cfg.dir.dist.app);
		fu.deleteFolderRecursive(cfg.dir.dist.editor);
		rollup(cfg.dir.src.app.js,cfg.dir.dist.app,{entry:'index.js'},bopts,function(e){
			if (e) {
				if (cb) { cb(e); return; }
				console.log(clc.error(e.toString()));
				return;
			} else {
				//if (cb) { cb(); return; }
				if (!cb) { console.log(clc.empty('app distribution finished'));}
				rollup(cfg.dir.src.editor.js,cfg.dir.dist.editor,{entry:'index.js'},boptse,function(e){
					if (e) {
						if (cb) { cb(e); return; }
						console.log(clc.error(e.toString())); return;
					}
					console.log(clc.empty('editor distribution finished'));
					
					console.log(clc.empty('copying app static files...'));
					copyStatics(cfg.dir.src.app.static,cfg.dir.dist.app,function(e){
						if (e) {
							if (cb) { cb(e); return; }
							console.log(clc.error(e.toString())); return;
						}
						console.log(clc.empty('copying editor static files...'));
						copyStatics(cfg.dir.src.editor.static,cfg.dir.dist.editor,function(e){
							if (e) {
								if (cb) { cb(e); return; }
								console.log(clc.error(e.toString())); return;
							}
							console.log(clc.info('build completed'));
							if (cb) { cb(); return; }
						})
					});
				});
			}
		});
	};
};

function copyStatics(from,to,cb){
	ncp(from,to,function(e){
		if (e) { return cb(e); }
		cb();
	});
}
