var cs = require('../change_case');
var f;
module.exports=function(fu){
	f=fu;
	var clc=f.clc,
		wd=f.workingdir,
		cfg,
		id;
		
	try {
		cfg=require(wd+'esm.json');
		
	} catch(err) {
		cfg=null;
	}
	if (cfg) {
		id=cs.camel(cfg.name);
	}
	return function(cb){
		if (!id) {
			console.log(clc.error(f.msg.esm_pkg_doesnt_exists));
			return;
		}
		//console.log('p==>',f.p);
		//process.exit();
		var scs=f.p.subcommand,
			libName,
			sc,
			isEd=(f.p.options && (f.p.options.e || f.p.options.editor));
			
		if (scs && scs.length) {
			scs=!Array.isArray(scs)?[scs]:scs;
			sc=scs[0];
			if (scs.length > 1) {
				libName=scs[1];
			}
			
			if (sc=='ls') {
				ls(cfg,isEd);
			} else if(sc=='add' || sc=='install'){
				if (!libName) {
					console.log(clc.empty(f.sprintf(f.msg.invalid_params,'library_id')));
					return;
				}
				return f.request(f.apiurl+'lib/'+libName,function(e, r, body) {
					if (e) {
						console.log(clc.error(f.msg.error + e.toString()));
						return;
					}
					var o=JSON.parse(body);
					if (!o.s) {
						console.log(clc.error((o.err||o.error).toString()));
						return;
					}
					if (!o.dt) {
						console.log(clc.empty(f.sprintf(f.msg.lib_not_found,libName)));
						return;
					}
					//console.log(body);
					add(cfg,libName,isEd);
					save(cfg);
				});
			} else if(sc=='rem' || sc=='remove' || sc=='del' || sc=='delete' || sc=='uninstall'){
				if (!libName) {
					console.log(clc.empty(f.sprintf(f.msg.invalid_params,'library_id')));
					return;
				}
				remove(cfg,libName,isEd);
				save(cfg);
			} else {
				console.log(clc.error(f.sprintf(f.msg.invalid_sub_command,sc)))
			}
		} else {
			ls(cfg,isEd);
		}
	};
};

function ls(cfg,isEd) {
	var l=isEd?'editorLibs':'libs';
	if (cfg[l] && cfg[l].length) {
		f.formatOutput(cfg[l],2);
	} else {
		console.log(clc.empty(f.msg.no_lib_deps))
	}
}

function add(cfg,lib,isEd) {
	var l=isEd?'editorLibs':'libs';
	cfg[l]=cfg[l]||[];
	if (cfg[l].indexOf(lib) < 0) {
		cfg[l].push(lib);
	}
}

function remove(cfg,lib,isEd) {
	var l=isEd?'editorLibs':'libs';
	cfg[l]=cfg[l]||[];
	var i=cfg[l].indexOf(lib);
	if (i > -1) {
		cfg[l].splice(i,1);
	}
}

function save(cfg){
	f.createFile(f.esmpackage,JSON.stringify(cfg,true,'  '),function(r){
		if (r) {
			console.log(f.clc.info(f.msg.pkg_updated));
		} else {
			console.log(f.clc.red(f.sprint(f.msg.cannot_write_file,'esm.json')));
		}
	});
}