var func=null;
var clc=null;
module.exports=function(fu){
	func=fu;
	clc=func.clc;
	return function(){
		function _login(u,p){
			func.request.post({url:func.apiurl+'login',form:{username:u,password:p}}, function (error, response, body) {
				if (!error && response.statusCode == 200) {
					var rslt= JSON.parse(body);
					if (rslt && rslt.auth && rslt.auth.name) {
						console.log(clc.bold.cyan('success:')+' username = '+rslt.auth.name);
					} else if(rslt && rslt.err){
						console.log(clc.red(rslt.err));
					}
				} else {
					console.log(clc.red(error));
				}
			});
		}
		var u=func.arguments('user','u');
		var p=func.arguments('password','p');
		if (!p || !u) {
			var schema={};
			if (!u) {
				schema.username={
					pattern: /^[\w\-]+$/,
					message: 'Name can only contains word or dashes',
					required: true
				};
			}
			if (!p) {
				schema.password={silent: true,required: true};
			}
			func.prompt(schema,function (err, result) {
				if (!result) {
					console.log('\n'+clc.empty('login cancelled'));
					return;
				}
				u=result.username?result.username:u;
				p=result.password?result.password:p;
				_login(u,p);
			});
		} else {
			_login(u,p);
		}
	};
};