module.exports = {
  reporter: function (res) {
    var len = res.length;
    var str = "";
	var file="";
    res.forEach(function (r) {
      file = r.file;
      var err = r.error;

      str += "    line " + err.line + ", col " +
        err.character + ", " + err.reason + "\n";
    });

    if (str) {
      process.stdout.write(file+":\n"+str +"  "+ len + " error" +
        ((len === 1) ? "" : "s") + "\n");
    }
  }
};